SystemOrganization addCategory: #Compatibility!

!Boolean methodsFor: '*compatibility' stamp: 'StephaneDucasse 6/27/2010 18:19'!
and: block1 and: block2
	"Nonevaluating conjunction without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as false, then return false immediately,
		without evaluating any further blocks.
	If all return true, then return true."
	
	self deprecated: 'use and:'.
	self ifFalse: [^ false].
	block1 value ifFalse: [^ false].
	block2 value ifFalse: [^ false].
	^ true! !

!Boolean methodsFor: '*compatibility' stamp: 'StephaneDucasse 4/27/2010 11:46'!
and: block1 and: block2 and: block3
	"Nonevaluating conjunction without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as false, then return false immediately,
		without evaluating any further blocks.
	If all return true, then return true."
	
	self deprecated: 'Use and: instead'. 
	
	self ifFalse: [^ false].
	block1 value ifFalse: [^ false].
	block2 value ifFalse: [^ false].
	block3 value ifFalse: [^ false].
	^ true! !

!Boolean methodsFor: '*compatibility' stamp: 'StephaneDucasse 5/26/2010 21:35'!
and: block1 and: block2 and: block3 and: block4
	"Nonevaluating conjunction without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as false, then return false immediately,
		without evaluating any further blocks.
	If all return true, then return true."

	self deprecated: 'Use and: instead'. 
	
	self ifFalse: [^ false].
	block1 value ifFalse: [^ false].
	block2 value ifFalse: [^ false].
	block3 value ifFalse: [^ false].
	block4 value ifFalse: [^ false].
	^ true! !

!Boolean methodsFor: '*compatibility' stamp: 'jannik.laval 2/5/2010 21:41'!
or: block1 or: block2
	"Nonevaluating alternation without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as true, then return true immediately,
		without evaluating any further blocks.
	If all return false, then return false."
	self deprecated:'use a or:[b or:[c]] instead'.
	self ifTrue: [^ true].
	block1 value ifTrue: [^ true].
	block2 value ifTrue: [^ true].
	^ false! !

!Boolean methodsFor: '*compatibility' stamp: 'jannik.laval 2/5/2010 21:42'!
or: block1 or: block2 or: block3
	"Nonevaluating alternation without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as true, then return true immediately,
		without evaluating any further blocks.
	If all return false, then return false."
	self deprecated:'use a or:[b or:[c or:[d]]] instead'.
	self ifTrue: [^ true].
	block1 value ifTrue: [^ true].
	block2 value ifTrue: [^ true].
	block3 value ifTrue: [^ true].
	^ false! !

!Boolean methodsFor: '*compatibility' stamp: 'jannik.laval 2/5/2010 21:42'!
or: block1 or: block2 or: block3 or: block4
	"Nonevaluating alternation without deep nesting.
	The receiver is evaluated, followed by the blocks in order.
	If any of these evaluates as true, then return true immediately,
		without evaluating any further blocks.
	If all return false, then return false."
	self deprecated:'use a or:[b or:[c or:[d or:[e]]]] instead'.
	self ifTrue: [^ true].
	block1 value ifTrue: [^ true].
	block2 value ifTrue: [^ true].
	block3 value ifTrue: [^ true].
	block4 value ifTrue: [^ true].
	^ false! !

StandardFileStream subclass: #CrLfFileStream
	instanceVariableNames: 'lineEndConvention'
	classVariableNames: 'Cr CrLf Lf LineEndDefault LineEndStrings LookAheadCount'
	poolDictionaries: ''
	category: 'Compatibility'!

!CrLfFileStream commentStamp: 'MarcusDenker 5/1/2011 14:04' prior: 0!
** in Compatibility Package as VMMaker needs is (why?)"

I have been deprecated in favour of a MultiByteFileStream with lineending conversion. The main difference is MultiByte supporting encoders other than the default for ascii mode.
The instance side methods have been left for posterity, but instance creation should now return a MultiByteFileStream with latin1 encoding, and default lineEndConvention.

I was the same as a regular file stream, except that when I was in text mode, I would automatically convert line endings between the underlying platform's convention, and Squeak's convention of carriage-return only.  The goal was that Squeak text files could be treated as OS text files, and vice versa.

In binary mode, I behaved identically to a StandardFileStream.


There were two caveats on programming with CrLfFileStream.

First, the choice of text mode versus binary mode affects which characters are visible in Squeak, and no longer just affects whether those characters are returned as Character's or as Integer's.  Thus the choice of mode needs to be made very carefully, and must be based on intent instead of convenience of representation.  The methods asString, asByteArray, asCharacter, and asInteger can be used to convert between character and integer representations.  (Arguably, file streams should accept either strings or characters in nextPut: and nextPutAll:, but that is not the case right now.)

Second, arithmetic on positions no longer worked, because one character that Squeak sees (carriage return) could map to two characters in the underlying file (carriage return plus line feed, on MS Windows and MS DOS).  Comparison between positions still works.  (This caveat could perhaps be fixed by maintaining a map between Squeak positions and positions in the underlying file, but it is complicated.  Consider, for example, updates to the middle of the file.  Also, consider that text files are rarely updated in the middle of the file, and that general random access to a text file is rarely very useful.  If general random access with specific file counts is desired, then the file is starting to sound like a binary file instead of a text file.)

!

!CrLfFileStream class methodsFor: 'initialization' stamp: 'HenrikSperreJohansen 3/10/2010 00:58'!
basicNew
	self deprecated: 'MultiByteFileStream should now be used for my functionality.'.
	
	"Return the old value if ignored. Can't say we didn't warn them"
	^super basicNew
	! !

!CrLfFileStream class methodsFor: 'initialization' stamp: 'HenrikSperreJohansen 3/10/2010 00:55'!
defaultToCR
	"CrLfFileStream defaultToCR"
	self substituteClass defaultToCR! !

!CrLfFileStream class methodsFor: 'initialization' stamp: 'HenrikSperreJohansen 3/10/2010 00:55'!
defaultToCRLF
	"CrLfFileStream defaultToCRLF"
	self substituteClass defaultToCRLF! !

!CrLfFileStream class methodsFor: 'initialization' stamp: 'HenrikSperreJohansen 3/10/2010 00:56'!
defaultToLF
	"CrLfFileStream defaultToLF"
	self substituteClass defaultToLF! !

!CrLfFileStream class methodsFor: 'class initialization' stamp: 'StephaneDucasse 8/3/2010 22:56'!
guessDefaultLineEndConvention
	^ self substituteClass guessDefaultLineEndConvention! !

!CrLfFileStream class methodsFor: 'initialization' stamp: 'MarcusDenker 5/1/2011 14:00'!
initialize
	"Don't bother, we are deprecated"
	"CrLfFileStream initialize"
	
	"Cr := Character cr.
	Lf := Character lf.
	CrLf := String with: Cr with: Lf.
	LineEndStrings := Dictionary new.
	LineEndStrings at: #cr put: (String with: Character cr).
	LineEndStrings at: #lf put: (String with: Character lf).
	LineEndStrings at: #crlf put: (String with: Character cr with: Character lf).
	LookAheadCount := 2048.
	Smalltalk addToStartUpList: self." "MultiByteFileStream is now there, we forward to it.
	self startUp."! !

!CrLfFileStream class methodsFor: 'initialization' stamp: 'StephaneDucasse 5/18/2011 23:04'!
new
	"I have been deprecated in favour of the equivalent MultiByteFileStream"
	self deprecated: 'This class is now obsolete, use MultiByteFileStream'.
	^ (MultiByteFileStream new) wantsLineEndConversion: true; yourself.

! !

!CrLfFileStream class methodsFor: 'deprecation' stamp: 'HenrikSperreJohansen 3/10/2010 00:55'!
substituteClass
	"The class which now provides my functionality"
	^MultiByteFileStream! !

!CrLfFileStream methodsFor: 'access' stamp: 'ar 1/20/98 16:16'!
ascii
	super ascii.
	self detectLineEndConvention! !

!CrLfFileStream methodsFor: 'access' stamp: 'stephaneducasse 2/4/2006 20:31'!
binary
	super binary.
	lineEndConvention := nil! !

!CrLfFileStream methodsFor: 'private' stamp: 'PeterHugossonMiller 9/3/2009 01:04'!
convertStringFromCr: aString 
	| inStream outStream |
	lineEndConvention ifNil: [^ aString].
	lineEndConvention == #cr ifTrue: [^ aString].
	lineEndConvention == #lf ifTrue: [^ aString copy replaceAll: Cr with: Lf].
	"lineEndConvention == #crlf"
	inStream := aString readStream.
	outStream := (String new: aString size) writeStream.
	[inStream atEnd]
		whileFalse: 
			[outStream nextPutAll: (inStream upTo: Cr).
			(inStream atEnd not or: [aString last = Cr])
				ifTrue: [outStream nextPutAll: CrLf]].
	^ outStream contents! !

!CrLfFileStream methodsFor: 'private' stamp: 'PeterHugossonMiller 9/3/2009 01:04'!
convertStringToCr: aString 
	| inStream outStream |
	lineEndConvention ifNil: [^ aString].
	lineEndConvention == #cr ifTrue: [^ aString].
	lineEndConvention == #lf ifTrue: [^ aString copy replaceAll: Lf with: Cr].
	"lineEndConvention == #crlf"
	inStream := aString readStream.
	outStream := (String new: aString size) writeStream.
	[inStream atEnd]
		whileFalse: 
			[outStream nextPutAll: (inStream upTo: Cr).
			(inStream atEnd not or: [aString last = Cr])
				ifTrue: 
					[outStream nextPut: Cr.
					inStream peek = Lf ifTrue: [inStream next]]].
	^ outStream contents! !

!CrLfFileStream methodsFor: 'access' stamp: 'stephaneducasse 2/4/2006 20:31'!
detectLineEndConvention
	"Detect the line end convention used in this stream. The result may be either #cr, #lf or #crlf."
	| char numRead pos |
	self isBinary ifTrue: [^ self error: 'Line end conventions are not used on binary streams'].
	lineEndConvention := LineEndDefault.
	"Default if nothing else found"
	numRead := 0.
	pos := super position.
	[super atEnd not and: [numRead < LookAheadCount]]
		whileTrue: 
			[char := super next.
			char = Lf
				ifTrue: 
					[super position: pos.
					^ lineEndConvention := #lf].
			char = Cr
				ifTrue: 
					[super peek = Lf
						ifTrue: [lineEndConvention := #crlf]
						ifFalse: [lineEndConvention := #cr].
					super position: pos.
					^ lineEndConvention].
			numRead := numRead + 1].
	super position: pos.
	^ lineEndConvention! !

!CrLfFileStream methodsFor: 'access' stamp: 'nk 9/5/2004 12:58'!
lineEndConvention

	^lineEndConvention! !

!CrLfFileStream methodsFor: 'access' stamp: 'stephaneducasse 2/4/2006 20:31'!
next
    | char secondChar |
    char := super next.
    self isBinary ifTrue: [^char].
    char == Cr ifTrue:
        [secondChar := super next.
        secondChar ifNotNil: [secondChar == Lf ifFalse: [self skip: -1]].
        ^Cr].
    char == Lf ifTrue: [^Cr].
    ^char! !

!CrLfFileStream methodsFor: 'access' stamp: 'stephaneducasse 2/4/2006 20:31'!
next: n

		| string peekChar |
		string := super next: n.
		string size = 0 ifTrue: [ ^string ].
		self isBinary ifTrue: [ ^string ].

		"if we just read a CR, and the next character is an LF, then skip the LF"
		( string last = Character cr ) ifTrue: [
			peekChar := super next.		"super peek doesn't work because it relies on #next"
			peekChar ~= Character lf ifTrue: [
				super position: (super position - 1) ]. ].
 
		string := string withSqueakLineEndings.

		string size = n ifTrue: [ ^string ].

		"string shrunk due to embedded crlfs; make up the difference"
		^string, (self next: n - string size)! !

!CrLfFileStream methodsFor: 'access' stamp: 'ar 1/20/98 16:18'!
nextPut: char 
	(lineEndConvention notNil and: [char = Cr])
		ifTrue: [super nextPutAll: (LineEndStrings at: lineEndConvention)]
		ifFalse: [super nextPut: char].
	^ char! !

!CrLfFileStream methodsFor: 'access' stamp: 'ar 1/20/98 16:18'!
nextPutAll: aString 
	super nextPutAll: (self convertStringFromCr: aString).
	^ aString
! !

!CrLfFileStream methodsFor: 'open/close' stamp: 'stephaneducasse 2/4/2006 20:31'!
open: aFileName forWrite: writeMode 
	"Open the receiver.  If writeMode is true, allow write, else access will be 
	read-only. "
	| result |
	result := super open: aFileName forWrite: writeMode.
	result ifNotNil: [self detectLineEndConvention].
	^ result! !

!CrLfFileStream methodsFor: 'access' stamp: 'stephaneducasse 2/4/2006 20:31'!
peek
	"Answer what would be returned if the message next were sent to the receiver. If the receiver is at the end, answer nil.  "
	| next pos |
	self atEnd ifTrue: [^ nil].
	pos := self position.
	next := self next.
	self position: pos.
	^ next! !

!CrLfFileStream methodsFor: 'access' stamp: 'PeterHugossonMiller 9/3/2009 01:05'!
upTo: aCharacter
	| newStream char |
	newStream := (String new: 100) writeStream.
	[(char := self next) isNil or: [char == aCharacter]]
		whileFalse: [newStream nextPut: char].
	^ newStream contents
! !

!CrLfFileStream methodsFor: 'access' stamp: 'nice 12/7/2009 08:26'!
upToAnyOf: delimiters do: aBlock

	^String new: 1000 streamContents: [ :stream |
		| ch |
		[ (ch := self next) == nil or: [ (delimiters includes: ch) and: [aBlock value: ch. true] ] ] 
			whileFalse: [ stream nextPut: ch ] ]! !

!CrLfFileStream methodsFor: 'access' stamp: 'ar 1/20/98 16:18'!
verbatim: aString 
	super verbatim: (self convertStringFromCr: aString).
	^ aString! !

!BlockClosure methodsFor: '*compatibility' stamp: 'LucFabresse 2/10/2010 09:36'!
fixTemps
	"Fix the values of the temporary variables used in the block that
	 are  ordinarily shared with the method in which the block is defined.
	 This is a no-op for closures, provided for backward-compatibility with
	 old BlockContexts that needed the fixTemps hack to persist."
	 self deprecated: 'BlockClosure does not need to fixTemps'.! !

!SmalltalkImage methodsFor: '*compatibility' stamp: 'MarcusDenker 5/3/2011 19:30'!
hasBindingThatBeginsWith: aString
	^globals hasBindingThatBeginsWith: aString! !

!SmalltalkImage methodsFor: '*compatibility' stamp: 'MarcusDenker 5/1/2011 14:39'!
isMacOS

	self deprecated: 'Use OSPlatform'.
	^ self os isMacOS! !

!SmalltalkImage methodsFor: '*compatibility' stamp: 'MarcusDenker 5/1/2011 14:40'!
isUnix

	self deprecated: 'Use OSPlatform'.
	^ self os isUnix ! !

!SmalltalkImage methodsFor: '*compatibility' stamp: 'MarcusDenker 5/1/2011 14:40'!
isWin32

	self deprecated: 'Use OSPlatform'.
	^ self os isWin32 ! !

!SmalltalkImage methodsFor: '*compatibility' stamp: 'MarcusDenker 5/1/2011 14:40'!
isWin32CE

	self deprecated: 'Use OSPlatform'.
	^ self os isWin32CE! !

!SmalltalkImage methodsFor: '*compatibility' stamp: 'MarcusDenker 5/1/2011 14:40'!
isX11

	self deprecated: 'Use OSPlatform'.
	^ self os isX11! !

!SmalltalkImage methodsFor: '*compatibility' stamp: 'MarcusDenker 5/1/2011 14:40'!
osVersion
	"Return the version number string of the platform we're running on"
	"SmalltalkImage current osVersion"

	self deprecated: 'Use OSPlatform'.
	^ self os osVersion! !

!SmalltalkImage methodsFor: '*compatibility' stamp: ''!
platformName
	"Return the name of the platform we're running on"

	self deprecated: 'Use Smalltalk os platformName'.
	^self os platformName! !

!SmalltalkImage methodsFor: '*compatibility' stamp: 'MarcusDenker 5/1/2011 14:40'!
platformSubtype
	"Return the subType of the platform we're running on"

	self deprecated: 'Use OSPlatform'.
	^ self os platformSubtype ! !

!SmalltalkImage methodsFor: '*compatibility' stamp: 'MarcusDenker 5/1/2011 14:40'!
windowSystemName			
	"Return the name of the window system currently being used for display."
	"Smalltalk os windowSystemName"

	self deprecated: 'Use OSPlatform'.
	^ self os windowSystemName ! !

Morph subclass: #TheWorldMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compatibility'!

!TheWorldMenu commentStamp: 'StephaneDucasse 2/23/2010 21:10' prior: 0!
Just a placeholder so that old code can still load. !
CrLfFileStream initialize!
